SuperStrict
AppTitle = "BCC24"
Graphics 200,240
Global Image:TImage, Size:Int, CentralStart:Int, CentralStop:Int, Red:Int[,], Green:Int[,], Blue:Int[,]
Global PixelContrast:Int[,], PixelSelectionX:Int[], PixelSelectionY:Int[], SelectionCount:Int
'Die beiden folgenden Variablen sind DIE sensiblen Werte zur Erfassung der Symmetrieachse:
Global ContrastLimit:Int = 32
Global AxisStep:Float = 6 'Grad (bis 10)
Global StartArgument:String[] = AppArgs[1..]
'===================================
Repeat
'===================================
	If StartArgument = Null Or FileType(StartArgument[0]) <> 1 Then
		StartArgument = New String[1]
		StartArgument[0] = RequestFile("Load Image:", "Images:jpg,png,bmp;", False, CurrentDir())
		If StartArgument[0] = "" Then End
	End If
	'------------------------------------------------------------------
	Local Pixmap:TPixmap = LoadPixmap(StartArgument[0])
	Image = LoadImage(Pixmap)
	StartArgument = Null
	Size = PixmapWidth(Pixmap)
	Local Time:Int = MilliSecs()
	'Das Bilddrittel wird eingegrenzt:
	CentralStart = Size / 3.0
	CentralStop = 2.0 * Size / 3
	'Initalisierung der Felder fr Farben und Kontraste:
	Red = New Int[Size, Size]
	Green = New Int[Size, Size]
	Blue = New Int[Size, Size]
	PixelContrast = New Int[Size, Size]
	PixelSelectionX = New Int[Size*Size]
	PixelSelectionY = New Int[Size*Size]
	SelectionCount = -1
	Local x:Int, y:Int
	For x = 0 To Size - 1
		For y = 0 To Size - 1
			'Alle Farbwerte werden eingelesen:
			Local ARGB:Int = ReadPixel(Pixmap,x,y)
			Red[x,y] = Byte((ARGB & $00FF0000:Int) / $10000:Int) 
			Green[x,y] = Byte((ARGB & $0000FF00:Int) / $100:Int)
			Blue[x,y] = Byte(ARGB & $000000FF:Int)
			''Zeitversetzt" wird mit der Function "GetPixelContrast" fr jedes Pixel ermittelt,
			'wie gro der maximale Farbkontrast zu den acht umliegenden Pixeln ist:
			If x > 1 And y > 1 And x < Size - 1 And y < Size - 1 Then
				PixelContrast[x-1, y-1] = GetPixelContrast(x-1, y-1)
				'Falls er die sensible Grenze "ContrastLimit" bersteigt, wird der Punkt zu
				'einer Auswahl von "Kontrastpixeln" dazugezhlt und sich die Position gemerkt:
				If PixelContrast[x-1, y-1] > ContrastLimit Then
					SelectionCount = SelectionCount + 1
					PixelSelectionX[SelectionCount] = x-1
					PixelSelectionY[SelectionCount] = y-1
				End If
			End If
		Next
	Next
	'------------------------------------------------------------------
	Local Axis:Float[] = GetBestAxis() '(dies ist die Haupt-Function, siehe unten)
	DrawText "Time: " + (MilliSecs()-Time) + " Milliseconds", 10, 200
	DrawText "Please press a key ...", 10, 220
	DrawImage Image, 100-Size/2,100-Size/2
	SetLineWidth(2)
	DrawPointedLine(100-Size/2+Axis[0], 100-Size/2+Axis[1], 100-Size/2+Axis[2], 100-Size/2+Axis[3])
	Flip
	WaitKey()
	'------------------------------------------------------------------
	Cls
'===================================
Until KeyDown(KEY_ESCAPE) Or AppTerminate()
'===================================
End
'###################################
Function GetPixelContrast:Int(i:Int, j:Int)
	Local MaxContrastSum:Int = Abs(Red[i, j] - Red[i-1, j-1]) + Abs(Green[i, j] - Green[i-1, j-1]) + Abs(Blue[i, j] - Blue[i-1, j-1])
	Local ContrastSum:Int = Abs(Red[i, j] - Red[i, j-1]) + Abs(Green[i, j] - Green[i, j-1]) + Abs(Blue[i, j] - Blue[i, j-1])
	If ContrastSum > MaxContrastSum Then MaxContrastSum = ContrastSum
	ContrastSum = Abs(Red[i, j] - Red[i+1, j-1]) + Abs(Green[i, j] - Green[i+1, j-1]) + Abs(Blue[i, j] - Blue[i+1, j-1])
	If ContrastSum > MaxContrastSum Then MaxContrastSum = ContrastSum
	ContrastSum = Abs(Red[i, j] - Red[i-1, j]) + Abs(Green[i, j] - Green[i-1, j]) + Abs(Blue[i, j] - Blue[i-1, j])
	If ContrastSum > MaxContrastSum Then MaxContrastSum = ContrastSum
	ContrastSum = Abs(Red[i, j] - Red[i+1, j]) + Abs(Green[i, j] - Green[i+1, j]) + Abs(Blue[i, j] - Blue[i+1, j])
	If ContrastSum > MaxContrastSum Then MaxContrastSum = ContrastSum
	ContrastSum = Abs(Red[i, j] - Red[i-1, j+1]) + Abs(Green[i, j] - Green[i-1, j+1]) + Abs(Blue[i, j] - Blue[i-1, j+1])
	If ContrastSum > MaxContrastSum Then MaxContrastSum = ContrastSum
	ContrastSum = Abs(Red[i, j] - Red[i, j+1]) + Abs(Green[i, j] - Green[i, j+1]) + Abs(Blue[i, j] - Blue[i, j+1])
	If ContrastSum > MaxContrastSum Then MaxContrastSum = ContrastSum
	ContrastSum = Abs(Red[i, j] - Red[i+1, j+1]) + Abs(Green[i, j] - Green[i+1, j+1]) + Abs(Blue[i, j] - Blue[i+1, j+1])
	If ContrastSum > MaxContrastSum Then MaxContrastSum = ContrastSum
	Return MaxContrastSum/3
End Function
'###################################
Function GetBestAxis:Float[]()
	Local MostHits:Int, MemoX:Float, MemoAngle:Float, MemoY:Float = CentralStart
	Local StartAngle:Float, xy:Float, Angle:Float
	'Nun werden die potentiellen Achsen durchlaufen, die das Bilddritte durchlaufen.
	StartAngle = 90.0
	Repeat
		xy = CentralStart + Size / 3.0 * Tan(StartAngle-90)
		Angle = StartAngle
		Local StopAngle:Float = StartAngle - 45
		Repeat
			'------------------erst die Achse von Oben nach Unten:
			Local MemoPixelExamined:Byte[Size, Size]  'In diesem Feld wird gespeichert, ob ein Pixel bereits als Spiegelpunkt untersucht wurde
			Local CountFools:Int, CountHits:Int 'Hier zhlen wir, ob ein Spiegelpunkt ebenfalls zur Auswahl der Kontrastpixel gehrt oder nicht
			For Local k:Int = 0 To SelectionCount Step 2   '(dieser Ungenauigkeits-Kompromiss spart ebenfalls 'ne Menge Zeit, ohne aufzufallen)
				If MemoPixelExamined[PixelSelectionX[k], PixelSelectionY[k]] = False Then '(siehe Unten)
					'Das Folgende ist vom ausgewhlten Kontrastpixel der an der potentiellen Achse gespiegelte Punkt
					Local ReflectedPoint:Float[] = GetReflectedPoint(PixelSelectionX[k], PixelSelectionY[k], xy, CentralStart, Angle)
					'Dieser wird natrlich nur geprft, wenn er innerhalb des Bildes liegt:
					If ReflectedPoint[0] > 0 And ReflectedPoint[0] < Size And ReflectedPoint[1] > 0 And ReflectedPoint[1] < Size Then
						'Hier merken wir uns, dass dieser gespiegelte Punkte bereits geprft wurde, um dies nicht doppelt zu tun (siehe Oben)
						MemoPixelExamined[PixelSelectionX[k], PixelSelectionY[k]] = True
						'Falls nun der gespiegelte Punkt ebenfalls ein "kontrastreiches" Pixel ist, wird er als "Treffer" gezhlt:
						If PixelContrast[ReflectedPoint[0], ReflectedPoint[1]] > ContrastLimit Then
							CountHits = CountHits + 1
						Else    'ansonsten als "Fehlversuch":
							CountFools = CountFools + 1
						End If
					End If
					'Abbrechen, wenn die Anzahl der "Fehlversuche" bereits so gro ist, dass "Mosthits" nicht mehr berboten werden kann:
					If SelectionCount/2 - CountFools < MostHits Then Exit
				End If
			Next
			'Hiermit wird gemerkt, welche Achse die meisten "Treffer" gelandet hat und somit als Symmetrieachse interpretiert werden kann:
			If CountHits > MostHits Then
				MostHits = CountHits
				MemoX = xy
				MemoY = CentralStart
				MemoAngle = Angle
			End If
			'------------------und nun jene Achse von Links nach Rechts:
			MemoPixelExamined = New Byte[Size, Size]  'In diesem Feld wird gespeichert, ob ein Pixel bereits als Spiegelpunkt untersucht wurde
			CountFools = 0
			CountHits = 0 'Hier zhlen wir, ob ein Spiegelpunkt ebenfalls zur Auswahl der Kontrastpixel gehrt oder nicht
			For Local k:Int = 0 To SelectionCount Step 2   '(dieser Ungenauigkeits-Kompromiss spart ebenfalls 'ne Menge Zeit, ohne aufzufallen)
				If MemoPixelExamined[PixelSelectionX[k], PixelSelectionY[k]] = False Then '(siehe Unten)
					'Das Folgende ist vom ausgewhlten Kontrastpixel der an der potentiellen Achse gespiegelte Punkt
					Local ReflectedPoint:Float[] = GetReflectedPoint(PixelSelectionX[k], PixelSelectionY[k], Centralstart, xy, 90 - Angle)
					'Dieser wird natrlich nur geprft, wenn er innerhalb des Bildes liegt:
					If ReflectedPoint[0] > 0 And ReflectedPoint[0] < Size And ReflectedPoint[1] > 0 And ReflectedPoint[1] < Size Then
						'Hier merken wir uns, dass dieser gespiegelte Punkte bereits geprft wurde, um dies nicht doppelt zu tun (siehe Oben)
						MemoPixelExamined[PixelSelectionX[k], PixelSelectionY[k]] = True
						'Falls nun der gespiegelte Punkt ebenfalls ein "kontrastreiches" Pixel ist, wird er als "Treffer" gezhlt:
						If PixelContrast[ReflectedPoint[0], ReflectedPoint[1]] > ContrastLimit Then
							CountHits = CountHits + 1
						Else    'ansonsten als "Fehlversuch":
							CountFools = CountFools + 1
						End If
					End If
					'Abbrechen, wenn die Anzahl der "Fehlversuche" bereits so gro ist, dass "Mosthits" nicht mehr berboten werden kann:
					If SelectionCount/2 - CountFools < MostHits Then Exit
				End If
			Next
			'Hiermit wird gemerkt, welche Achse die meisten "Treffer" gelandet hat und somit als Symmetrieachse interpretiert werden kann:
			If CountHits > MostHits Then
				MostHits = CountHits
				MemoX = Centralstart
				MemoY = xy
				MemoAngle = 90-Angle
			End If
			'----------------------------------------------------------------------------------
			Angle = Angle - AxisStep
		Until Angle < StopAngle
		StartAngle = StartAngle + AxisStep
	Until StartAngle > 135
	'Die gemerke Symmetrieachse wird, leicht gestreckt, zurckgegeben:
	Return [ Float(MemoX - 188*Cos(MemoAngle)), Float(MemoY - 188*Sin(MemoAngle)), Float(MemoX + 188*Cos(MemoAngle)), Float(MemoY + 188*Sin(MemoAngle))]
End Function
'###################################
Function GetReflectedPoint:Float[](Px1:Int , Py1:Int , Px2:Int , Py2:Int, Angle:Float)
'Gibt den Spiegelpunkt des Punktes (Px1, Py1) zurck, der an jener Geraden gespiegelt
'wurde, welche durch den Punkt (Px2, Py2) und den Winkel "Angle" festgelegt ist
	Local IntersectionPoint:Float[] = GetIntersectionPoint(Px1, Py1, Angle+90, Px2 , Py2, Angle)
	Angle = GetAngle:Float(Px1, Py1, IntersectionPoint[0], IntersectionPoint[1]) 'das ist WIRKLICH ntig fr die Richtung
	Local Distance:Float = Sqr( (Px1 - IntersectionPoint[0])^2 + (Py1 - IntersectionPoint[1])^2 )
	Return [Float(IntersectionPoint[0] + Distance*Cos(Angle)), Float(IntersectionPoint[1] + Distance*Sin(Angle))]
End Function
'###################################
Function GetIntersectionPoint:Float[](Px1:Int, Py1:Int, Angle1:Float, Px2:Int, Py2:Int, Angle2:Float)
'Gibt den Schnittpunkt zurck, den die beiden Geraden miteinander haben, die durch (Px1, Py1)
'mit dem Winkel "Angle1" bzw. durch (Px2, Py2) mit dem Winkel "Angle2" verlaufen
	If Abs(Abs(Angle1 Mod 180) - Abs(Angle2 Mod 180)) < 0.001 Then Return Null
	Local Factor:Float, IntersectionPoint:Float[2]
	If Abs(Cos(Angle1)) < 0.001 Then
		Factor = 1.0 * (Px1-Px2) / Cos(Angle2)
		IntersectionPoint[0] = Px2 + Factor * Cos(Angle2)
		IntersectionPoint[1] = Py2 + Factor * Sin(Angle2)
	ElseIf Abs(Sin(Angle2)) < 0.001 Then
		Factor = 1.0 * (Py2-Py1) / Sin(Angle1)
		IntersectionPoint[0] = Px1 + Factor * Cos(Angle1)
		IntersectionPoint[1] = Py1 + Factor * Sin(Angle1)
	Else
		Factor = (Py1-Py2 + 1.0 * (Px2-Px1) * Tan(Angle1) ) / (Sin(Angle2)*(1-Tan(Angle1)/Tan(Angle2) ) )
		IntersectionPoint[0] = Px2 + Factor * Cos(Angle2)
		IntersectionPoint[1] = Py2 + Factor * Sin(Angle2)
	End If
	Return IntersectionPoint
End Function 
'###################################
Function GetAngle:Float(Px1:Int , Py1:Int , Px2:Int , Py2:Int)
'Gibt den (Steigungs-)Winkel zurck, den die beiden Punkte (Px1, Px1) und (Px2, Py2) miteinander haben.
	If Px1 < Px2 Then
		If Py1 < Py2 Then
			Return ATan(1.0 * (Py2 - Py1) / (Px2 - Px1) )
		Else
			Return 360+ATan(1.0 * (Py2 - Py1) / (Px2 - Px1) )
		End If
	ElseIf Px2 < Px1 Then
		Return (180 + ATan(1.0 * (Py2 - Py1) / (Px2 - Px1) ) )
	ElseIf Py1 < Py2 Then
		Return 90
	Else
		Return 270
	End If
End Function
'###################################
Function DrawPointedLine(X1:Float, Y1:Float, X2:Float, Y2:Float, PointLength:Int = 4, LineWidth:Int = 2)
'Zeichnet eine gestrichelte Linie.
	Local Length:Float = 1.0 * Sqr( (X2-X1)^2 + (Y2-Y1)^2 ) / PointLength - 1
	Local Angle:Float = GetAngle( X1, Y1, X2, Y2)
	Local SW:Int = 1
	For Local i:Int = 0 To Length
		SetColor 255, 128 + SW*127, 128 + SW*127
		SW = (-1) * SW
		X2 = X1 + PointLength * Cos(Angle)
		Y2 = Y1 + PointLength * Sin(Angle)
		DrawLine X1, Y1, X2, Y2
		X1 = X2
		Y1 = Y2
	Next
	SetColor 255,255,255
End Function
'###################################
